/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined (__LWMISC_H__)
#define __LWMISC_H__

#include "typedefs.h"
#include <stdio.h>

int validhair(short ID); // Is selected hair type valid
int validbeard(short b); // Is selected beard type valid
void addgold(int s, P_CHAR Player, int totgold);
void all_items(int s);
void batchcheck(int s);
int bestskill(P_CHAR pc);
int calcGoodValue(int actreg, P_ITEM pi, int value,int goodtype); // by Magius(CHE) for trade system
int calcValue(P_ITEM pi, int value);
void callguards(P_CHAR Caller);
void charcreate(UOXSOCKET s);	// All the character creation stuff
int chardir(P_CHAR pca, P_CHAR pcb);
void criminal(P_CHAR pc);
void deathstuff(P_CHAR Victim);
unsigned int dist(const cCoord&, const cCoord&); // Distance between position a and b
void doGmMoveEff(UOXSOCKET s); //gm movement effects
bool DoorIsBlockedByChar(P_ITEM pi);
void dooruse(int s, P_ITEM pi);
void dosocketmidi(int s);
void endmessage(int x);
void enlist(int s, int listnum); // For enlisting in army
void explodeitem(P_CHAR Player, P_ITEM pi);
void Fame(P_CHAR pc, int nFame);
void gcollect();
PC_ITEM GetOutmostCont(PC_ITEM pItem, short rec=50);
P_CHAR GetPackOwner(PC_ITEM pItem, short rec=50);
void goldsfx(int s, int goldtotal);
int hexnumber(int countx);
void impaction(int s, int act);
char indungeon(P_CHAR pc);

bool inrange1p(P_CHAR pca, P_CHAR pcb);

#define inrange1pl(a,b) _inrange1p(a, b, __LINE__, DBGFILE)
bool _inrange1p(P_CHAR pca, CHARACTER b, int cln, char* cfn);

int inrange2 (UOXSOCKET s, PC_ITEM pi);
bool inRange(const cCoord& a, const cCoord& b, int range);
bool inVisRange(int x1, int y1, int x2, int y2);
bool inVisRange(const cCoord &a, const cCoord &b);
bool IsDoor(short id);
int isTrueHuman(P_CHAR pc);
bool iteminrange (const UOXSOCKET s, const PC_ITEM pi, const int distance);
bool iteminrange (const P_CHAR Player, const PC_ITEM pi, const int distance);
void itemsfx(UOXSOCKET s, short item);
void Karma(P_CHAR pc, P_CHAR Victim, int nKarma);
void loadmetagm();
int makenumber(int countx);
void mounthorse(UOXSOCKET s, P_CHAR Mount);
void npcattacktarget(P_CHAR Attacker, P_CHAR Target);
void npcemoteall(P_CHAR pc, char *txt,unsigned char antispam);
void npcemoteall(int npc, char *txt,unsigned char antispam);
bool npcinrange (P_CHAR Player, P_CHAR pc, int distance);  //check for horse distance...
void npcsimpleattacktarget(P_CHAR Attacker, P_CHAR Target);
void npctalkall_runic(P_CHAR pc, char *txt,char antispam);
void npcToggleCombat(P_CHAR pc);
void openbank(int s, P_CHAR pc);
void openspecialbank(int s, P_CHAR pc);//AntiChrist
void bankcheck(cChar* pBanker, cChar* Player, int amount, UOXSOCKET s);
void bankwithdrawal(cChar* pBanker, cChar* pc, int amount, UOXSOCKET s);
void RefreshItem(P_ITEM pi);//AntiChrist
void savelog(const char *msg, char *logfile);
void scriptcommand (int s,  char *script1,  char *script2);
void setabovelight(unsigned char, int region);
void setcharflag(P_CHAR pc);
void splitline();
void StoreItemRandomValue(PC_ITEM pi,int tmpreg); // by Magius(CHE) (2) for trade system
void telltime(int s);
int unmounthorse(int s);
void wornitems(UOXSOCKET s, P_CHAR pc);
unsigned int itemdistDeluxe(P_CHAR a, const PC_ITEM pi);
void ExternalCommand(UOXSOCKET s, P_CHAR Player);
bool CVCS(UOXSOCKET s);
void doNPCPopupMenueAction(UOXSOCKET s);
bool makestring(int countx, char* str, bool upr = true);
void DeleteItemOnLayer(P_CHAR pc, int ly);
void numtoScriptCommand(short num, char* com);
short scriptCommandtoNum(char *sc);
void pdump(UOXSOCKET s, char type, FILE* file);
void makehousesUnmovable(void);
void makePlayerPosFile(void);

#endif
